(function($) {

	"use strict";

	/* Slider Initialize */
	aigpl_pro_album_slider_init();	

	/* Popup Gallery Initialize */
	aigpl_pro_popup_gallery_init();

	/* Masonry Initialize */
	aigpl_pro_album_masonry_init();

	/* Elementor Compatibility */
	$(document).on('click', '.elementor-tab-title', function() {

		var ele_control		= $(this).attr('aria-controls');
		var slider_wrap		= $('#'+ele_control).find('.aigpl-gallery-slider');
		var masonry_wrap	= $('#'+ele_control).find('.aigpl-gallery-masonry');

		$( slider_wrap ).each(function( index ) {

			var slider_id = $(this).attr('id');

			/* Tweak for slick slider */
			if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
				$('#'+slider_id).slick( 'setPosition' );
			}
		});

		/* Tweak for masonry */
		$( masonry_wrap ).each(function( index ) {

			var masonry_id = $(this).attr('id');

			if( typeof(masonry_id) !== 'undefined' && masonry_id != '' ) {
				$('#'+masonry_id).masonry( 'resize' );
			}
		});
	});

	/* SiteOrigin Compatibility For Accordion Panel */
	$(document).on('click', '.sow-accordion-panel', function() {

		var ele_control	= $(this).attr('data-anchor');
		var slider_id	= $('#accordion-content-'+ele_control).find('.aigpl-gallery-slider').attr('id');
		var masonry_id	= $('#accordion-content-'+ele_control).find('.aigpl-gallery-masonry').attr('id');

		/* Tweak for slick slider */
		if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
			$('#'+slider_id).slick( 'setPosition' );
		}

		/* Tweak for masonry */
		if( typeof(masonry_id) !== 'undefined' && masonry_id != '' ) {
			$('#'+masonry_id).masonry( 'resize' );
		}
	});

	/* SiteOrigin Compatibility for Tab Panel */
	$(document).on('click focus', '.sow-tabs-tab', function() {
		var sel_index	= $(this).index();
		var cls_ele		= $(this).closest('.sow-tabs');
		var tab_cnt		= cls_ele.find('.sow-tabs-panel').eq( sel_index );
		var slider_id	= tab_cnt.find('.aigpl-gallery-slider').attr('id');
		var masonry_id	= tab_cnt.find('.aigpl-gallery-masonry').attr('id');

		$('#'+slider_id).css({'visibility': 'hidden', 'opacity': 0});

		setTimeout(function() {

			/* Tweak for slick slider */
			if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
				$('#'+slider_id).slick( 'setPosition' );
				$('#'+slider_id).css({'visibility': 'visible', 'opacity': 1});
			}

			/* Tweak for masonry */
			if( typeof(masonry_id) !== 'undefined' && masonry_id != '' ) {
				$('#'+masonry_id).masonry( 'resize' );
			}
		}, 300);
	});

	/* Beaver Builder Compatibility for Accordion */
	$(document).on('click', '.fl-accordion-item', function() {

		var cls_ele		= $(this).closest('.fl-accordion');
		var ele_control	= cls_ele.find('.fl-accordion-button').attr('aria-controls');
		var slider_id	= tab_cnt.find('.aigpl-gallery-slider').attr('id');
		var masonry_id	= tab_cnt.find('.aigpl-gallery-masonry').attr('id');

		/* Tweak for slick slider */
		if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
			$('#'+slider_id).slick( 'setPosition' );
		}

		/* Tweak for masonry */
		if( typeof(masonry_id) !== 'undefined' && masonry_id != '' ) {
			$('#'+masonry_id).masonry( 'resize' );
		}
	});

	/* Beaver Builder Compatibility for Tabs */
	$(document).on('click', '.fl-tabs-label', function() {

		var ele_control	= $(this).attr('aria-controls');
		var slider_id	= tab_cnt.find('.aigpl-gallery-slider').attr('id');
		var masonry_id	= tab_cnt.find('.aigpl-gallery-masonry').attr('id');

		/* Tweak for slick slider */
		if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
			$('#'+slider_id).slick( 'setPosition' );
		}

		/* Tweak for masonry */
		if( typeof(masonry_id) !== 'undefined' && masonry_id != '' ) {
			$('#'+masonry_id).masonry( 'resize' );
		}
	});

	/* Initialize album lightbox */
	$(document).on('click', '.aigpl-lightbox-gallery .aigpl-img-link', function(e) {

		e.preventDefault();

		var cls_ele = $(this).closest('.aigpl-cnt-wrp');

		/* Enable loader */
		$('.aigpl-lightbox-loader').remove();
		$('body').append('<div class="aigpl-lightbox-loader">'+AigplPro.loading_text+'</div>');
		$('.aigpl-lightbox-loader').animate({bottom: '50px'}, 400);

		/* Ajax */
		var data = {
			action		: 'aigpl_pro_get_album_images',
			album_id	: cls_ele.attr('data-id'),
		};

		$.post(AigplPro.ajaxurl,data,function(response) {
			var result = $.parseJSON(response);

			if( result.success == 1 && result.data ) {

				$('.aigpl-ilightbox-popup .ilightbox-close').trigger('click');

				$.iLightBox(result.data, {
					skin				:'metro-black aigpl-ilightbox-popup',
					path				: 'horizontal',
					minScale			: 0.075,
					smartRecognition	: false,
					isMobile			: true,
					show				: {
											title	: true,
											speed	: 400
										},
					caption				: {
											start	: true,
											show	: '',
											hide	: ''
										},
					controls			: {
											slideshow	: true,
											arrows		: true,
										},
					overlay				: {
											opacity	: 0.97
										},
					slideshow			: {
											pauseTime		: 3000,
											pauseOnHover	: false,
											startPaused		: true
										},
					text				: {
											close			: AigplPro.popup_close_text,
											enterFullscreen	: AigplPro.popup_fullscreen,
											exitFullscreen	: AigplPro.popup_exitfullscreen,
											slideShow		: AigplPro.popup_slideshow,
											next			: AigplPro.popup_next_text,
											previous		: AigplPro.popup_prev_text
										},
				});
				$('.aigpl-lightbox-loader').remove();
			} else {
				$('.aigpl-lightbox-loader').addClass('aigpl-lightbox-loader-err').html(result.msg);
			}

			setTimeout(function() {
				$(".aigpl-lightbox-loader").fadeOut("normal", function() {
					$(this).remove();
				});
			}, 2000 );
		});
	});
})(jQuery);

/* Function to Initialize Album Slider */
function aigpl_pro_album_slider_init() {
	jQuery( '.aigpl-gallery-slider' ).each(function( index ) {

		if( jQuery(this).hasClass('slick-initialized') ) {
			return;
		}

		var slider_id	= jQuery(this).attr('id');
		var slider_conf	= jQuery.parseJSON( jQuery(this).closest('.aigpl-gallery-slider-wrp').attr('data-conf'));

		jQuery('#'+slider_id).slick({
			lazyLoad		: slider_conf.lazyload,
			speed			: parseInt( slider_conf.speed ),
			autoplaySpeed	: parseInt( slider_conf.autoplay_interval ),
			slidesToShow	: parseInt( slider_conf.slidestoshow ),
			slidesToScroll	: parseInt( slider_conf.slidestoscroll ),
			dots			: ( slider_conf.dots == "true" )			? true	: false,
			infinite		: ( slider_conf.loop == "true" )			? true	: false,
			arrows			: ( slider_conf.arrows == "true" )			? true	: false,
			autoplay		: ( slider_conf.autoplay == "true" )		? true	: false,
			centerMode		: ( slider_conf.centermode == "true" )		? true	: false,
			pauseOnHover	: ( slider_conf.hover_pause == "false" )	? false	: true,
			pauseOnFocus	: ( slider_conf.focus_pause == "true" )		? true	: false,
			rtl				: ( AigplPro.is_rtl == 1 )					? true	: false,
			mobileFirst		: ( AigplPro.is_mobile == 1 )				? true	: false,
			responsive		: [{
				breakpoint	: 1023,
				settings	: {
								slidesToShow	: ( parseInt( slider_conf.slidestoshow ) > 3 ) ? 3 : parseInt( slider_conf.slidestoshow ),
								slidesToScroll	: 1,
								infinite		: ( slider_conf.loop == "true" )	? true : false,
								dots			: ( slider_conf.dots == "true" )	? true : false,
							}
			},{
				breakpoint	: 767,
				settings	: {
					slidesToShow	: ( parseInt( slider_conf.slidestoshow ) > 2 ) ? 2 : parseInt( slider_conf.slidestoshow ),
					slidesToScroll	: 1,
					infinite		: ( slider_conf.loop == "true" )	? true : false,
					dots			: ( slider_conf.dots == "true" )	? true : false,
					centerMode		: false,
				}
			},{
				breakpoint	: 479,
				settings	: {
					slidesToShow	: 1,
					slidesToScroll	: 1,
					dots			: false,
					centerMode		: false,
					infinite		: ( slider_conf.loop == "true" ) ? true : false,
				}
			},{
				breakpoint	: 319,
				settings	: {
					slidesToShow	: 1,
					slidesToScroll	: 1,
					dots			: false,
					centerMode		: false,
					infinite		: ( slider_conf.loop == "true" ) ? true : false,
				}
			}]
		});
	});
}

/* Function to Initialize Album Gallery Popup */
function aigpl_pro_popup_gallery_init() {
	jQuery( '.aigpl-popup-gallery' ).each(function( index ) {

		var gallery_id	= jQuery(this).attr('id');
		var total_item	= jQuery('#'+gallery_id+' .aigpl-cnt-wrp:not(.slick-cloned) a.aigpl-img-link').length;

		if( typeof('gallery_id') !== 'undefined' && gallery_id != '' ) { //.slick-image-slide:not(.slick-cloned) a
			jQuery('#'+gallery_id).magnificPopup({
				tClose		: AigplPro.popup_close_text,
				delegate	: '.aigpl-cnt-wrp a.aigpl-img-link',
				type		: 'image',
				mainClass	: 'aigpl-mfp-popup',
				tLoading	: AigplPro.mfp_loading_text,
				gallery		: {
								tPrev				: AigplPro.popup_prev_text,
								tNext				: AigplPro.popup_next_text,
								enabled				: true,
								navigateByImgClick	: true,
								preload				: [0,1], /* Will preload 0 - before current, and 1 after the current image*/
								tCounter			: ''
							},
				image		: {
								tError		: AigplPro.mfp_img_error,
								titleSrc	: function(item) {
												return item.el.closest('.aigpl-img-wrp').find('.aigpl-img').attr('title');
											}
							},
				zoom		: {
								enabled		: false,
								duration	: 300, /* don't foget to change the duration also in CSS*/
								opener		: function(element) {
												return element.closest('.aigpl-img-wrp').find('.aigpl-img');
											}
							},
				callbacks	: {
								markupParse	: function(template, values, item) {
									var current_indx	= item.el.closest('.aigpl-cnt-wrp').attr('data-item-index');
									var counter_text	= AigplPro.mfp_img_counter;
									counter_text		= counter_text.replace('%curr%', current_indx);
									counter_text		= counter_text.replace('%total%', total_item);
									values.counter		= counter_text;

									jQuery('body').trigger('aigpl_mfp_markup_parse', [ template, values, item ]);
								}
							},
			});
		}
	});
}

/* Function to Initialize Album Masonry */
function aigpl_pro_album_masonry_init() {
	jQuery('.aigpl-gallery-masonry').each(function( index ) {

		var obj_id		= jQuery(this).attr('id');
		var container	= jQuery('#'+obj_id);

		/* Creating object */
		var masonry_param_obj = {itemSelector: '.aigpl-cnt-wrp'};

		if( !jQuery(this).hasClass('aigpl-effect-1') ) {
			masonry_param_obj['transitionDuration'] = 0;
		}

		container.imagesLoaded( function() {
			container.masonry(masonry_param_obj);
		});
	});
}