( function($) {

	'use strict';

	jQuery(window).on('elementor/frontend/init', function() {

		/* Shortcode Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/shortcode.default', function() {
			aigpl_pro_album_slider_init();
			aigpl_pro_album_masonry_init();
			aigpl_pro_popup_gallery_init();
		});

		/* Text Editor Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/text-editor.default', function() {
			aigpl_pro_album_slider_init();
			aigpl_pro_album_masonry_init();
			aigpl_pro_popup_gallery_init();
		});

		/* Tabs Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/tabs.default', function( $scope ) {

			$scope.find('.aigpl-gallery-slider').each(function( index ) {

				var slider_id = $(this).attr('id');
				$('#'+slider_id).css({'visibility': 'hidden', 'opacity': 0});

				aigpl_pro_album_slider_init();

				setTimeout(function() {

					/* Tweak for slick slider */
					if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
						$('#'+slider_id).slick( 'setPosition' );
						$('#'+slider_id).css({'visibility': 'visible', 'opacity': 1});
					}
				}, 300);
			});

			aigpl_pro_album_masonry_init();
			aigpl_pro_popup_gallery_init();
		});

		/* Accordion Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/accordion.default', function( $scope ) {

			$scope.find('.aigpl-gallery-slider').each(function( index ) {

				var slider_id = $(this).attr('id');
				$('#'+slider_id).css({'visibility': 'hidden', 'opacity': 0});

				aigpl_pro_album_slider_init();

				setTimeout(function() {

					/* Tweak for slick slider */
					if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
						$('#'+slider_id).slick( 'setPosition' );
						$('#'+slider_id).css({'visibility': 'visible', 'opacity': 1});
					}
				}, 300);
			});

			aigpl_pro_popup_gallery_init();
			aigpl_pro_album_masonry_init();
		});

		/* Toggle Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/toggle.default', function( $scope ) {

			$scope.find('.aigpl-gallery-slider').each(function( index ) {
				var slider_id = $(this).attr('id');
				$('#'+slider_id).css({'visibility': 'hidden', 'opacity': 0});

				aigpl_pro_album_slider_init();

				setTimeout(function() {

					/* Tweak for slick slider */
					if( typeof(slider_id) !== 'undefined' && slider_id != '' ) {
						$('#'+slider_id).slick( 'setPosition' );
						$('#'+slider_id).css({'visibility': 'visible', 'opacity': 1});
					}
				}, 300);
			});

			aigpl_pro_album_masonry_init();
			aigpl_pro_popup_gallery_init();
		});

		/* Album Slider Shortcode Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/wp-widget-aigpl-gas-shrt.default', function() {
			aigpl_pro_album_slider_init();
			aigpl_pro_popup_gallery_init();
		});

		/* Album Gallery Shortcode Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/wp-widget-aigpl-ga-shrt.default', function() {
			aigpl_pro_album_masonry_init();
			aigpl_pro_popup_gallery_init();
		});

		/* Gallery Slider Shortcode Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/wp-widget-aigpl-gs-shrt.default', function() {
			aigpl_pro_album_slider_init();
			aigpl_pro_popup_gallery_init();
		});

		/* Gallery Grid Shortcode Element */
		elementorFrontend.hooks.addAction( 'frontend/element_ready/wp-widget-aigpl-gallery-shrt.default', function() {
			aigpl_pro_album_masonry_init();
			aigpl_pro_popup_gallery_init();
		});
	});
})(jQuery);