<?php
/**
 * Shortcode Fields for Shortcode Preview  
 *
 * @package Album and Image Gallery Plus Lightbox Pro 
 * @since 1.3
 */

if ( !defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

/**
 * Generate 'aigpl-gallery' shortcode fields for preview
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.2.6
 */
function aigpl_gallery_shortcode_fields() { 
 
	$fields = array(
			// General fields
			'general' => array(
					'title'     => __('General Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'   	=>  array(
								// General settings
								array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Album Post ID', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'id',
										'value' 		=> '',
										'desc' 			=> sprintf(__( 'Enter id of the Album. You can find id at listing <a href="%1$s" target="_blank">page</a>.', 'album-and-image-gallery-plus-lightbox'), add_query_arg( array( 'post_type' => AIGPL_PRO_POST_TYPE ), 'edit.php' )) . '<label title="'.__('Note: You must have to pass the Album ID. You can pass multiple ids by comma seperated.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Design', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'design',
										'value' 		=> aigpl_pro_gallery_designs(),
										'desc' 			=> __( 'Choose gallery design.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Grid', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'grid',
										'value' 		=> array(
																'1'		=> __( 'Grid 1', 'album-and-image-gallery-plus-lightbox' ),
																'2'		=> __( 'Grid 2', 'album-and-image-gallery-plus-lightbox' ),
																'3'		=> __( 'Grid 3', 'album-and-image-gallery-plus-lightbox' ),
																'4'		=> __( 'Grid 4', 'album-and-image-gallery-plus-lightbox' ),
																'5'		=> __( 'Grid 5', 'album-and-image-gallery-plus-lightbox' ),
																'6'		=> __( 'Grid 6', 'album-and-image-gallery-plus-lightbox' ),
																'7'		=> __( 'Grid 7', 'album-and-image-gallery-plus-lightbox' ),
																'8'		=> __( 'Grid 8', 'album-and-image-gallery-plus-lightbox' ),
																'9'		=> __( 'Grid 9', 'album-and-image-gallery-plus-lightbox' ),
																'10'	=> __( 'Grid 10', 'album-and-image-gallery-plus-lightbox' ),
																'11'	=> __( 'Grid 11', 'album-and-image-gallery-plus-lightbox' ),
																'12'	=> __( 'Grid 12', 'album-and-image-gallery-plus-lightbox' ),
														),
										'default'		=> 3,
										'desc' 			=> __( 'Choose number of columns for gallery image.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Title', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_title',
										'value' 		=> array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',	
										'desc' 			=> __( 'Show title.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Description', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_description',
										'value' 		=> array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Show description.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Display Caption', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_caption',
										'value' 		=> array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display read more button or not.', 'album-and-image-gallery-plus-lightbox' )
									),
									array(
										'type'			=> 'text',
										'heading'		=> __( 'Media Image Size', 'album-and-image-gallery-plus-lightbox'),
										'name'			=> 'image_size',
										'value' 		=> 'full',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Choose WordPress registered image size. ', 'album-and-image-gallery-plus-lightbox' ).'e.g thumbnail, medium, large, full.',
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Gallery Height', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'gallery_height',
										'value' 		=> '',
										'desc' 			=> __( 'Control height of the gallery image. You can enter any numeric number. e.g 500. Leave empty for default height.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Open Image in Popup', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'popup',
										'value' 		=> array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display gallery image in a popup.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Link Behaviour', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'link_target',
										'value' 		=> array(
																'self' 		=> __( 'Same Window', 'album-and-image-gallery-plus-lightbox' ),
																'blank' 	=> __( 'New Window', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Choose link bahaviour.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> array(
																'element' 	=> 'popup',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Offset', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'offset',
										'value' 		=> '',
										'desc' 			=> __( 'Space between two gallery images. You can enter any numeric number. e.g 5', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Masonry View', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'masonry',
										'value' 		=> array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ), 
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery images in a masonry layout.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Extra Class', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'extra_class',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Enter extra CSS class for design customization.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('Note: Extra class added as parent so using extra class you customize your design.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
								),
			),
	);
	return $fields;
}

/**
 * Generate 'aigpl-gallery-slider' shortcode fields for preview
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.2.6
 */
function aigpl_gallery_slider_shortcode_fields() {

	$fields = array(
			// General fields
			'general' => array(
					'title'     => __('General Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'    =>  array(
									// General settings
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Album Post ID', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'id',
										'value' 		=> '',
										'desc' 			=> sprintf(__( 'Enter id of the Album. You can find id at listing <a href="%1$s" target="_blank">page</a>.', 'album-and-image-gallery-plus-lightbox'), add_query_arg( array( 'post_type' => AIGPL_PRO_POST_TYPE ), 'edit.php' )) . '<label title="'.__('Note: You must have to pass the Album ID. You can pass multiple ids by comma seperated.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Design', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'design',
										'value' 		=> aigpl_pro_gallery_designs(),
										'desc' 			=> __( 'Choose gallery slider design.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Title', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_title',
										'value' 		=> array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery image title.', 'album-and-image-gallery-plus-lightbox' )
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Description', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_description',
										'value' 		=> array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery image description.', 'album-and-image-gallery-plus-lightbox' )
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Display Caption', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_caption',
										'value' 		=> array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display gallery image caption.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Media Image Size', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'image_size',
										'value' 		=> 	'full',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Choose WordPress registered image size. ', 'album-and-image-gallery-plus-lightbox' ).'e.g thumbnail, medium, large, full.',
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Open Image in Popup', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'popup',
										'value' 		=> 	array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display gallery image in a popup.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Link Behaviour', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'link_target',
										'value' 		=> array(
																'self' 	=> __( 'Same Window', 'album-and-image-gallery-plus-lightbox' ),
																'blank' => __( 'New Window', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Choose link bahaviour.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> array(
																'element' 	=> 'popup',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Gallery Height', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'gallery_height',
										'value' 		=> '',
										'desc' 			=> __( 'Control height of the gallery image. You can enter any numeric number. e.g 500. Leave empty for default height.', 'album-and-image-gallery-plus-lightbox' ),
									),	
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Extra Class', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'extra_class',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Enter extra CSS class for design customization.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('Note: Extra class added as parent so using extra class you customize your design.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
								)
			),

			// Data Settings	
			'slider' => array(
					'title'		=> __('Slider Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'    => array(
									// Slider Setting
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Slides Column', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'slidestoshow',
										'value' 		=> 3,
										'desc' 			=> __( 'Enter number of column for slider.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Slide To Scroll', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'slidestoscroll',
										'value' 		=> 1,
										'desc' 			=> __( 'Enter number of slides to scroll at a time.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Slider Dots', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'dots',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Show pagination dots.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type'			=> 'dropdown',
										'heading'		=> __( 'Show Slider Arrows', 'album-and-image-gallery-plus-lightbox' ),
										'name'			=> 'arrows',
										'value'			=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ) ,
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Show Prev - Next arrows.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Autoplay', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'autoplay',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ) ,
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'true',
										'desc' 			=> __( 'Enable autoplay.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Autoplay Interval', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'autoplay_interval',
										'value' 		=> 3000,
										'desc' 			=> __( 'Enter autoplay speed.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'autoplay',
																'value' 	=> array( 'true' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Speed', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'speed',
										'value' 		=> 300,
										'desc' 			=> __( 'Enter slide speed.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Infinite', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'loop',
										'value' 		=> 	array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Enable infinite loop for continuous sliding.', 'album-and-image-gallery-plus-lightbox' ),
									
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Center Mode', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'centermode',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Enable centered view with partial prev/next slides. Use with odd numbered `Slides to Scroll` and `Slider Column` counts.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 		=> 'dropdown',
										'heading' 	=> __( 'Pause On Hover', 'album-and-image-gallery-plus-lightbox' ),
										'name' 		=> 'hover_pause',
										'value' 	=> array(
															'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
															'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
														),
										'desc' 		=> __( 'Pause slider autoplay on hover.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency'=> array(
															'element' 	=> 'autoplay',
															'value' 	=> array( 'true' ),
														),
									),
										array(
										'type'		=> 'dropdown',
										'heading'	=> __( 'Pause On Focus', 'album-and-image-gallery-plus-lightbox' ),
										'name'		=> 'focus_pause',
										'value'		=> array(
															'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
															'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
														),
										'default'	=> 'false',
										'desc'		=> __( 'Pause slider autoplay when slider element is focused.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency'=> array(
															'element' 	=> 'autoplay',
															'value' 	=> array( 'true' ),
														),
									),
									array(
										'type' 		=> 'dropdown',
										'heading' 	=> __( 'Slider Lazyload', 'album-and-image-gallery-plus-lightbox' ),
										'name' 		=> 'lazyload',
										'value' 	=> array(
															'' 				=> __( 'Select Lazyload', 'album-and-image-gallery-plus-lightbox' ),
															'ondemand' 		=> __( 'Ondemand', 'album-and-image-gallery-plus-lightbox' ),
															'progressive' 	=> __( 'Progressive', 'album-and-image-gallery-plus-lightbox' ),
													),
										'desc' 		=> __( 'Select option to use lazy loading in slider.', 'album-and-image-gallery-plus-lightbox' ),
									),
								)
			),
	);
	return $fields;
}

/**
 * Generate 'aigpl-gallery-album' shortcode fields for preview
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.2.6
 */
function aigpl_gallery_album_shortcode_fields() { 

	$fields = array(
			// General fields
			'general' => array(
					'title'     => __('General Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'    =>  array(
									// General settings
									
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Extra Class', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'extra_class',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Enter extra CSS class for design customization.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('Note: Extra class added as parent so using extra class you customize your design.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Media Image Size', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'image_size',
										'value' 		=> 	'full',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Choose WordPress registered image size. ', 'album-and-image-gallery-plus-lightbox' ).'e.g thumbnail, medium, large, full.',
									),
								)
			),

			// General fields
			'album' => array(
					'title'     => __('Album Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'    =>  array(
									// Album settings
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Album Design', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_design',
										'value' 		=> aigpl_pro_album_designs(),
										'desc' 			=> __( 'Choose album design.', 'album-and-image-gallery-plus-lightbox'),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Album Grid', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_grid',
										'value' 		=> array(
																'1'		=> __( 'Grid 1', 'album-and-image-gallery-plus-lightbox' ),
																'2'		=> __( 'Grid 2', 'album-and-image-gallery-plus-lightbox' ),
																'3'		=> __( 'Grid 3', 'album-and-image-gallery-plus-lightbox' ),
																'4'		=> __( 'Grid 4', 'album-and-image-gallery-plus-lightbox' ),
																'5'		=> __( 'Grid 5', 'album-and-image-gallery-plus-lightbox' ),
																'6'		=> __( 'Grid 6', 'album-and-image-gallery-plus-lightbox' ),
																'7'		=> __( 'Grid 7', 'album-and-image-gallery-plus-lightbox' ),
																'8'		=> __( 'Grid 8', 'album-and-image-gallery-plus-lightbox' ),
																'9'		=> __( 'Grid 9', 'album-and-image-gallery-plus-lightbox' ),
																'10'	=> __( 'Grid 10', 'album-and-image-gallery-plus-lightbox' ),
																'11'	=> __( 'Grid 11', 'album-and-image-gallery-plus-lightbox' ),
																'12'	=> __( 'Grid 12', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 3,
										'desc' 			=> __( 'Choose number of columns for albums.', 'album-and-image-gallery-plus-lightbox' ),
										),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Album Title', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_title',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display album title.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Description', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_description',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display album description.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Full Content', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_full_content',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display album full description.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_description',
																'value' 	=> array( 'true' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Content Word Limit for Album', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'words_limit',
										'value' 		=> 40,
										'desc' 			=> __( 'Display number of words for album description.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_full_content',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Content Tail', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'content_tail',
										'value' 		=> '...',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Display dots after the album content as continue reading.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_full_content',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Album Height', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_height',
										'value' 		=> '',
										'desc' 			=> __( 'Control height of the album. You can enter any numeric number. e.g 500', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Total Photos', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'total_photo',
										'value' 		=> '{total}'.' '.__('Photos','album-and-image-gallery-plus-lightbox'),
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Control photo count label. "{total}" will replace the number of album photos.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Album Popup', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_popup',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display album image in a popup.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Link Behaviour', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_link_target',
										'value' 		=> 	array(
																'self' 	=> __( 'Same Window', 'album-and-image-gallery-plus-lightbox' ),
																'blank' => __( 'New Window', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Choose link behaviour whether to open in a new tab or not.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_popup',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Masonry View', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_masonry',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display album in a masonry layout.', 'album-and-image-gallery-plus-lightbox' ),
									),
								)
			),
			// Data Fields
			'data' => array(
					'title'		=> __('Gallery Parameters', 'album-and-image-gallery-plus-lightbox'),
					'desc'		=> __("Note: This all parameters only works if you had chosen 'Album Behaviour' as a 'Page Reload'.", 'album-and-image-gallery-plus-lightbox'),
					'params'    => array(
									// Data Setting
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Design', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'design',
										'value' 		=> aigpl_pro_gallery_designs(),
										'desc' 			=> __( 'Choose gallery images design. Display when you click on any album.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Grid', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'grid',
										'value' 		=> array(
																'1'		=> __( 'Grid 1', 'album-and-image-gallery-plus-lightbox' ),
																'2'		=> __( 'Grid 2', 'album-and-image-gallery-plus-lightbox' ),
																'3'		=> __( 'Grid 3', 'album-and-image-gallery-plus-lightbox' ),
																'4'		=> __( 'Grid 4', 'album-and-image-gallery-plus-lightbox' ),
																'5'		=> __( 'Grid 5', 'album-and-image-gallery-plus-lightbox' ),
																'6'		=> __( 'Grid 6', 'album-and-image-gallery-plus-lightbox' ),
																'7'		=> __( 'Grid 7', 'album-and-image-gallery-plus-lightbox' ),
																'8'		=> __( 'Grid 8', 'album-and-image-gallery-plus-lightbox' ),
																'9'		=> __( 'Grid 9', 'album-and-image-gallery-plus-lightbox' ),
																'10'	=> __( 'Grid 10', 'album-and-image-gallery-plus-lightbox' ),
																'11'	=> __( 'Grid 11', 'album-and-image-gallery-plus-lightbox' ),
																'12'	=> __( 'Grid 12', 'album-and-image-gallery-plus-lightbox' ),
														),
										'default'		=> 3,
										'desc' 			=> __( 'Choose number of column for image gallery.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Title', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_title',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery image title.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Description', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_description',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery image description.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Caption', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_caption',
										'value' 		=> array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display gallery image caption.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Popup Image', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'popup',
										'value' 		=> 	array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display gallery image in a popup.', 'album-and-image-gallery-plus-lightbox' ),
										),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Link Behaviour', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'link_target',
										'value' 		=> 	array(
																'self' 	=> __( 'Same Window', 'album-and-image-gallery-plus-lightbox' ),
																'blank' => __( 'New Window', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Choose link bahaviour.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'popup',
																'value' 	=> array( 'false' ),
															),
										),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Gallery Height', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'gallery_height',
										'value' 		=> '',
										'desc' 			=> __( 'Control height of the gallery image. You can enter any numeric number. e.g 500. Leave empty for default height.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Offset (Space Between Two Images)', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'offset',
										'value' 		=> '',
										'desc' 			=> __( 'Space between two gallery images. You can enter any numeric number. e.g 5', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Masonry View', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'masonry',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery images in a masonry layout.', 'album-and-image-gallery-plus-lightbox' ),
									),
								)
			),
		
			// slider Fields
			'query' => array(
					'title'		=> __('Query Settings', 'album-and-image-gallery-plus-lightbox'),
					'params'    => array(
									// data Settings
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Total Items', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'limit',
										'min' 			=> -1,
										'value' 		=> 15,
										'desc' 			=> __( 'Enter number of album to be displayed. Enter -1 to display all.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Post Order By', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'orderby',
										'value' 		=> 	array(
																'date' 			=> __( 'Album Date', 'album-and-image-gallery-plus-lightbox' ),
																'title' 		=> __( 'Album Title', 'album-and-image-gallery-plus-lightbox' ),
																'modified' 		=> __( 'Album Modified Date', 'album-and-image-gallery-plus-lightbox' ),
																'rand' 			=> __( 'Random', 'album-and-image-gallery-plus-lightbox' ),
																'menu_order'	=> __( 'Menu Order', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Select order type.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Post Sort Order', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'order',
										'value' 		=> array(
																'desc'	=> __( 'Descending', 'album-and-image-gallery-plus-lightbox' ),
																'asc'	=> __( 'Ascending', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Select sorting order.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Display Specific Category', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'category',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Enter category id to display categories wise.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant category listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Include Category Children', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'include_cat_child',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ) ,
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'If you are using parent category then whether to display child category or not.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Exclude Category', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'exclude_cat',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Exclude post category. Works only if `Category` field is empty.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant category listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Display Specific Album', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'id',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __('Enter id of the post which you want to display.', 'album-and-image-gallery-plus-lightbox') . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant post listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Exclude Album', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'exclude_post',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __('Enter id of the post which you do not want to display.', 'album-and-image-gallery-plus-lightbox') . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant post listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Pagination', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'pagination',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'dependency' 	=> 	array(
																'element' 				=> 'limit',
																'value_not_equal_to' 	=> '-1',
															),
										'desc' 			=> __( 'Display Pagination.', 'album-and-image-gallery-plus-lightbox'),
										
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Pagination Type', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'pagination_type',
										'value' 		=> 	array(
																'numeric'	=> __( 'Numeric', 'album-and-image-gallery-plus-lightbox' ),
																'prev-next'	=> __( 'Next-Prev', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display Pagination for album post', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'pagination',
																'value_not_equal_to' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Query Offset', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'query_offset',
										'value' 		=> '',
										'desc' 			=> __( 'Exclude number of posts from starting.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('e.g if you pass 5 then it will skip first five post. Note: This will not work with limit=-1.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
								)
			),
	);
	return $fields;
}

/**
 * Generate 'aigpl-gallery-album-slider' shortcode fields for preview
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.2.6
 */
function aigpl_gallery_album_slider_shortcode_fields() {

	$fields = array(
			// General fields
			'general' => array(
					'title'     => __('General Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'    =>  array(
									// General settings
									array(
										'type' 			=> 'text',
										'refresh_time'	=> 1000,
										'heading' 		=> __( 'Extra Class', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'extra_class',
										'value' 		=> '',
										'desc' 			=> __( 'Enter extra CSS class for design customization.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('Note: Extra class added as parent so using extra class you customize your design.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'text',
										'refresh_time'	=> 1000,
										'heading' 		=> __( 'Media Image Size', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'image_size',
										'value' 		=> 	'full',
										'desc' 			=> __( 'Choose WordPress registered image size. ', 'album-and-image-gallery-plus-lightbox' ).'e.g thumbnail, medium, large, full.',
									),
								)
			),

			// Album fields
			'album' => array(
					'title'     => __('Album Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'    =>  array(
									// Album settings
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Album Design', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_design',
										'value' 		=> aigpl_pro_album_designs(),
										'desc' 			=> __( 'Choose album design.', 'album-and-image-gallery-plus-lightbox'),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Album Title', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_title',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display album title.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Description', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_description',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display album description.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Full Content', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_full_content',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display album full description.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_description',
																'value' 	=> array( 'true' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Content Word Limit for Album', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'words_limit',
										'value' 		=> 40,
										'desc' 			=> __( 'Display number of words for album description.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_full_content',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Content Tail', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'content_tail',
										'value' 		=> '...',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Display dots after the album content as continue reading.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_full_content',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Album Height', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_height',
										'value' 		=> '',
										'desc' 			=> __( 'Control height of the album. You can enter any numeric number. e.g 500', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 				=> 'text',
										'heading' 			=> __( 'Total Photos', 'album-and-image-gallery-plus-lightbox' ),
										'name' 				=> 'total_photo',
										'value' 			=> '{total}'.' '.__('Photos','album-and-image-gallery-plus-lightbox'),
										'refresh_time'		=> 1000,
										'desc' 				=> __( 'Control photo count label. "{total}" will replace the number of album photos.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Popup', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_popup',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Choose album gallery behaviour.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Link Behaviour', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_link_target',
										'value' 		=> 	array(
																'self' 	=> __( 'Same Window', 'album-and-image-gallery-plus-lightbox' ),
																'blank' => __( 'New Window', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Choose link behaviour whether to open in a new tab or not.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_popup',
																'value' 	=> array( 'false' ),
															),
									),
								)
			),
			// Album Gallery Setting
			'data' => array(
					'title'     => __('Album Gallery Parameters', 'album-and-image-gallery-plus-lightbox'),
					'desc'		=> __("Note: This all parameters only works if you had chosen 'Album Behaviour' as a 'Page Reload'.", 'album-and-image-gallery-plus-lightbox'),
					'params'    =>  array(
									// Album Galleryl settings
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Design', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'design',
										'value' 		=> aigpl_pro_gallery_designs(),
										'desc' 			=> __( 'Choose Gallery Images design. Display when you click on any Album.', 'album-and-image-gallery-plus-lightbox' ),
										'admin_label' 	=> true,
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Grid', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'grid',
										'value' 		=> array(
																'1'		=> __( 'Grid 1', 'album-and-image-gallery-plus-lightbox' ),
																'2'		=> __( 'Grid 2', 'album-and-image-gallery-plus-lightbox' ),
																'3'		=> __( 'Grid 3', 'album-and-image-gallery-plus-lightbox' ),
																'4'		=> __( 'Grid 4', 'album-and-image-gallery-plus-lightbox' ),
																'5'		=> __( 'Grid 5', 'album-and-image-gallery-plus-lightbox' ),
																'6'		=> __( 'Grid 6', 'album-and-image-gallery-plus-lightbox' ),
																'7'		=> __( 'Grid 7', 'album-and-image-gallery-plus-lightbox' ),
																'8'		=> __( 'Grid 8', 'album-and-image-gallery-plus-lightbox' ),
																'9'		=> __( 'Grid 9', 'album-and-image-gallery-plus-lightbox' ),
																'10'	=> __( 'Grid 10', 'album-and-image-gallery-plus-lightbox' ),
																'11'	=> __( 'Grid 11', 'album-and-image-gallery-plus-lightbox' ),
																'12'	=> __( 'Grid 12', 'album-and-image-gallery-plus-lightbox' ),
														),
										'default'		=> 3,
										'desc' 			=> __( 'Choose number of column for image gallery.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Title', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_title',
										'value' 		=> 	array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery image Title.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Description', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_description',
										'value' 		=> 	array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery image description.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Caption', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'show_caption',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display gallery image caption.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Popup Image', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'popup',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Display gallery image in a popup.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Gallery Image Link Behaviour', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'link_target',
										'value' 		=> 	array(
																'self' 	=> __( 'Same Window', 'album-and-image-gallery-plus-lightbox' ),
																'blank' => __( 'New Window', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Choose link bahaviour.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'popup',
																'value' 	=> array( 'false' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Gallery Height', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'gallery_height',
										'value' 		=> '',
										'desc' 			=> __( 'Control height of the gallery image. You can enter any numeric number. e.g 500. Leave empty for default height.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Offset (Space Between Two Images)', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'offset',
										'value' 		=> '',
										'desc' 			=> __( 'Space between two gallery images. You can enter any numeric number. e.g 5', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Masonry View', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'masonry',
										'value' 		=> 	array( 
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Display gallery images in a masonry layout.', 'album-and-image-gallery-plus-lightbox' ),
									),
								)
			),	           	
			// Data Settings	
			'slider' => array(
					'title'		=> __('Album Slider', 'album-and-image-gallery-plus-lightbox'),
					'params'    => array(
									// Slider Setting
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Slides Column', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_slidestoshow',
										'value' 		=> 3,
										'desc' 			=> __( 'Enter number of column for album slider.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Scroll Slides', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_slidestoscroll',
										'value' 		=> 1,
										'desc' 			=> __( 'Enter number of slides to scroll at a time.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Dots', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_dots',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Show dots indicators.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Show Arrows', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_arrows',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Show Prev - Next arrows.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Autoplay', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_autoplay',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Enable autoplay.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Autoplay Interval', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_autoplay_interval',
										'value' 		=> 3000,
										'desc' 			=> __( 'Enter autoplay speed.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency' 	=> 	array(
																'element' 	=> 'album_autoplay',
																'value' 	=> array( 'true' ),
															),
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Speed', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_speed',
										'value' 		=> 300,
										'desc' 			=> __( 'Enter slide speed.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Infinite', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_loop',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Enable infinite loop for continuous sliding.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Center Mode', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'album_centermode',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'default'		=> 'false',
										'desc' 			=> __( 'Enable centered view with partial prev/next slides. Use with odd numbered `Slides to Scroll` and `Slider Column` counts.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 		=> 'dropdown',
										'heading' 	=> __( 'Pause On Hover', 'album-and-image-gallery-plus-lightbox' ),
										'name' 		=> 'hover_pause',
										'value' 	=> array(
															'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
															'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
														),
										'desc' 		=> __( 'Pause slider autoplay on hover.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency'=> array(
															'element' 	=> 'album_autoplay',
															'value' 	=> array( 'true' ),
														),
									),
									array(
										'type'		=> 'dropdown',
										'heading'	=> __( 'Pause On Focus', 'album-and-image-gallery-plus-lightbox' ),
										'name'		=> 'focus_pause',
										'value'		=> array(
															'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
															'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
														),
										'default'	=> 'false',
										'desc'		=> __( 'Pause slider autoplay when slider element is focused.', 'album-and-image-gallery-plus-lightbox' ),
										'dependency'=> array(
															'element' 	=> 'album_autoplay',
															'value' 	=> array( 'true' ),
														),
									),
									array(
										'type' 		=> 'dropdown',
										'heading' 	=> __( 'Slider Lazyload', 'album-and-image-gallery-plus-lightbox' ),
										'name' 		=> 'lazyload',
										'value' 	=> array(
															'' 				=> __( 'Select Lazyload', 'album-and-image-gallery-plus-lightbox' ),
															'ondemand' 		=> __( 'Ondemand', 'album-and-image-gallery-plus-lightbox' ),
															'progressive' 	=> __( 'Progressive', 'album-and-image-gallery-plus-lightbox' ),
													),
										'desc' 		=> __( 'Select option to use lazy loading in slider.', 'album-and-image-gallery-plus-lightbox' ),
									),
								)
			),
			 // Data Settings
			'query' => array(
					'title'     => __('Query Parameters', 'album-and-image-gallery-plus-lightbox'),
					'params'    =>  array(
									// Album Galleryl settings
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Total Items', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'limit',
										'value' 		=> 15,
										'min' 			=> -1,
										'desc' 			=> __( 'Enter number of album to be displayed. Enter -1 to display all.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Post Order By', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'orderby',
										'value' 		=> 	array(
																'date' 			=> __( 'Album Date', 'album-and-image-gallery-plus-lightbox' ),
																'title' 		=> __( 'Album Title', 'album-and-image-gallery-plus-lightbox' ),
																'modified' 		=> __( 'Album Modified Date', 'album-and-image-gallery-plus-lightbox' ),
																'rand' 			=> __( 'Random', 'album-and-image-gallery-plus-lightbox' ),
																'menu_order'	=> __( 'Menu Order', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Select order type.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Post Sort Order', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'order',
										'value' 		=> 	array(
																'desc'	=> __( 'Descending', 'album-and-image-gallery-plus-lightbox' ),
																'asc'	=>  __( 'Ascending', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'Select sorting order.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Display Specific Category', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'category',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Enter category id to display categories wise.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant category listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'dropdown',
										'heading' 		=> __( 'Include Category Children', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'include_cat_child',
										'value' 		=> 	array(
																'true'	=> __( 'True', 'album-and-image-gallery-plus-lightbox' ),
																'false'	=> __( 'False', 'album-and-image-gallery-plus-lightbox' ),
															),
										'desc' 			=> __( 'If you are using parent category then whether to display child category or not.', 'album-and-image-gallery-plus-lightbox' ),
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Exclude Category', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'exclude_cat',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Exclude post category. Works only if `Category` field is empty.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant category listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Display Specific Album', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'id',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __('Enter id of the post which you want to display.', 'album-and-image-gallery-plus-lightbox') . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant post listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'text',
										'heading' 		=> __( 'Exclude Album', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'exclude_post',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __('Enter id of the post which you do not want to display.', 'album-and-image-gallery-plus-lightbox') . '<label title="'.__('You can pass multiple ids with comma seperated. You can find id at relevant post listing page.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
									array(
										'type' 			=> 'number',
										'heading' 		=> __( 'Query Offset', 'album-and-image-gallery-plus-lightbox' ),
										'name' 			=> 'query_offset',
										'value' 		=> '',
										'refresh_time'	=> 1000,
										'desc' 			=> __( 'Exclude number of posts from starting.', 'album-and-image-gallery-plus-lightbox' ) . '<label title="'.__('e.g if you pass 5 then it will skip first five post. Note: This will not work with limit=-1.', 'album-and-image-gallery-plus-lightbox').'"> [?]</label>',
									),
								)
				),	
	);
	return $fields;
}