<?php
/**
 * Blocks Initializer
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.3
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

function aigpl_pro_register_guten_block() {

	// Some Variables
	$shrt_gen_link = add_query_arg( array( 'post_type' => AIGPL_PRO_POST_TYPE, 'page' => 'aigpl-shrt-mapper' ), admin_url('edit.php') );

	wp_register_script( 'aigpl-pro-block-js', AIGPL_PRO_URL.'assets/js/blocks.build.js', array( 'wp-blocks', 'wp-i18n', 'wp-element', 'wp-editor', 'wp-components' ), AIGPL_PRO_VERSION, true );
	wp_localize_script( 'aigpl-pro-block-js', 'Aigpl_Pro_Block', array(
																	'shrt_gen_link'				=> $shrt_gen_link,
																	'album_slider_shrt_link'	=> add_query_arg( array( 'shortcode' => 'aigpl-gallery-album-slider' ), $shrt_gen_link ),
																	'gallery_shrt_link'			=> add_query_arg( array( 'shortcode' => 'aigpl-gallery' ), $shrt_gen_link ),
																	'gallery_slider_shrt_link'	=> add_query_arg( array( 'shortcode' => 'aigpl-gallery-slider' ), $shrt_gen_link ),
																));

	// Register block and explicit attributes for grid
	register_block_type( 'aigpl-pro/album-gallery', array(
		'attributes' => array(
			'image_size' => array(
							'type'		=> 'string',
							'default'	=> 'full',
						),
			'album_design' => array(
							'type'		=> 'string',
							'default'	=> 'design-1',
						),
			'album_grid' => array(
							'type'		=> 'number',
							'default'	=> 3,
						),
			'album_title' => array(
							'type'		=> 'boolean',
							'default'	=> true,
						),
			'album_description' => array(
							'type'		=> 'boolean',
							'default'	=> true,
						),
			'album_full_content' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'words_limit' => array(
							'type'		=> 'number',
							'default'	=> 40,
						),
			'content_tail' => array(
							'type'		=> 'string',
							'default'	=> '...',
						),
			'album_height' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'total_photo' => array(
							'type'		=> 'string',
							'default'	=> '{total}'.' '.'Photos',
						),
			'album_popup' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'album_link_target' => array(
							'type'		=> 'string',
							'default'	=> 'self',
						),
			'album_masonry' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'design' => array(
							'type'		=> 'string',
							'default'	=> 'design-1',
						),
			'grid' => array(
							'type'		=> 'number',
							'default'	=> 3,
						),
			'show_title' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'show_description' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'show_caption' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'popup' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'link_target' => array(
							'type'		=> 'string',
							'default'	=> 'self',
						),
			'gallery_height' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'offset' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'masonry' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'limit' => array(
							'type'		=> 'number',
							'default'	=> 15,
						),
			'orderby' => array(
							'type'		=> 'string',
							'default'	=> 'date',
						),
			'order' => array(
							'type'		=> 'string',
							'default'	=> 'DESC',
						),
			'category' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'include_cat_child' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'exclude_cat' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'id' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'exclude_post' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'pagination' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'pagination_type' => array(
							'type'		=> 'string',
							'default'	=> 'numeric',
						),
			'query_offset' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'align' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'className' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
		),
		'render_callback' => 'aigpl_pro_gallery_album',
	));

	// Register block, and explicitly define the attributes for slider
	register_block_type( 'aigpl-pro/album-gallery-slider', array(
		'attributes' => array(
			'image_size' => array(
							'type'		=> 'string',
							'default'	=> 'full',
						),
			'album_design' => array(
							'type'		=> 'string',
							'default'	=> 'design-1',
						),
			'album_title' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'album_description' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'album_full_content' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'words_limit' => array(
							'type'		=> 'number',
							'default'	=> 40,
						),
			'content_tail' => array(
							'type'		=> 'string',
							'default'	=> '...',
						),
			'album_height' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'total_photo' => array(
							'type'		=> 'string',
							'default'	=> '{total}'.' '.'Photos',
						),
			'album_popup' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'album_link_target' => array(
							'type'		=> 'string',
							'default'	=> 'self',
						),
			'design' => array(
							'type'		=> 'string',
							'default'	=> 'design-1',
						),
			'grid' => array(
							'type'		=> 'number',
							'default'	=> 3,
						),
			'show_title' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'show_description' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'show_caption' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'popup' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'link_target' => array(
							'type'		=> 'string',
							'default'	=> 'self',
						),
			'gallery_height' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'offset' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'masonry' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'album_slidestoshow' => array(
							'type'		=> 'number',
							'default'	=> 3,
						),
			'album_slidestoscroll' => array(
							'type'		=> 'number',
							'default'	=> 1,
						),
			'album_dots' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'album_arrows' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'album_autoplay' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'album_autoplay_interval' => array(
							'type'		=> 'number',
							'default'	=> 3000,
						),
			'album_speed' => array(
							'type'		=> 'number',
							'default'	=> 300,
						),
			'album_loop' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'album_centermode' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'hover_pause' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'focus_pause' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'lazyload' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'limit' => array(
							'type'		=> 'number',
							'default'	=> 15,
						),
			'orderby' => array(
							'type'		=> 'string',
							'default'	=> 'date',
						),
			'order' => array(
							'type'		=> 'string',
							'default'	=> 'DESC',
						),
			'category' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'include_cat_child' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'exclude_cat' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'id' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'exclude_post' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'query_offset' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'align' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'className' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
		),
		'render_callback' => 'aigpl_pro_gallery_album_slider',
	));

	// Register block, and explicitly define the attributes for slider
	register_block_type( 'aigpl-pro/gallery', array(
		'attributes' => array(
			'id' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'design' => array(
							'type'		=> 'string',
							'default'	=> 'design-1',
						),
			'grid' => array(
							'type'		=> 'number',
							'default'	=> 3,
						),
			'show_title' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'show_description' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'show_caption' => array(
							'type'		=> 'boolean',
							'default'	=> true,
						),
			'image_size' => array(
							'type'		=> 'string',
							'default'	=> 'full',
						),
			'gallery_height' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'popup' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'link_target' => array(
							'type'		=> 'string',
							'default'	=> 'self',
						),
			'offset' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'masonry' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'align' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'className' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
		),
		'render_callback' => 'aigpl_pro_gallery_grid',
	));

	// Register block, and explicitly define the attributes for slider
	register_block_type( 'aigpl-pro/gallery-slider', array(
		'attributes' => array(
			'id' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'design' => array(
							'type'		=> 'string',
							'default'	=> 'design-1',
						),
			'show_title' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'show_description' => array(
							'type'		=> 'boolean',
							'default'	=> false,
						),
			'show_caption' => array(
							'type'		=> 'boolean',
							'default'	=> true,
						),
			'image_size' => array(
							'type'		=> 'string',
							'default'	=> 'full',
						),
			'popup' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'link_target' => array(
							'type'		=> 'string',
							'default'	=> 'self',
						),
			'gallery_height' => array(
							'type'		=> 'number',
							'default'	=> '',
						),
			'slidestoshow' => array(
							'type'		=> 'number',
							'default'	=> 3,
						),
			'slidestoscroll' => array(
							'type'		=> 'number',
							'default'	=> 1,
						),
			'dots' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'arrows' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'autoplay' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'autoplay_interval' => array(
							'type'		=> 'number',
							'default'	=> 3000,
						),
			'speed' => array(
							'type'		=> 'number',
							'default'	=> 300,
						),
			'loop' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'centermode' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'hover_pause' => array(
							'type'		=> 'string',
							'default'	=> 'true',
						),
			'focus_pause' => array(
							'type'		=> 'string',
							'default'	=> 'false',
						),
			'lazyload' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'align' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
			'className' => array(
							'type'		=> 'string',
							'default'	=> '',
						),
		),
		'render_callback' => 'aigpl_pro_gallery_slider',
	));

	if ( function_exists( 'wp_set_script_translations' ) ) {
		wp_set_script_translations( 'aigpl-pro-block-js', 'album-and-image-gallery-plus-lightbox', AIGPL_PRO_DIR . '/languages' );
	}

}
add_action( 'init', 'aigpl_pro_register_guten_block' );

/**
 * Enqueue Gutenberg block assets for backend editor.
 *
 * @uses {wp-blocks} for block type registration & related functions.
 * @uses {wp-element} for WP Element abstraction — structure of blocks.
 * @uses {wp-i18n} to internationalize the block's text.
 * @uses {wp-editor} for WP editor styles.
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.3
 */
function aigpl_pro_editor_assets() {	

	// Block Editor CSS
	if( ! wp_style_is( 'wpos-guten-block-css', 'registered' ) ) {
		wp_register_style( 'wpos-guten-block-css', AIGPL_PRO_URL.'assets/css/blocks.editor.build.css', array( 'wp-edit-blocks' ), AIGPL_PRO_VERSION );
	}

	// Block Editor Script
	wp_enqueue_style( 'wpos-guten-block-css' );
	wp_enqueue_script( 'aigpl-pro-block-js' );
}
add_action( 'enqueue_block_editor_assets', 'aigpl_pro_editor_assets' );

/**
 * Adds an extra category to the block inserter
 *
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.3
 */
function aigpl_pro_add_block_category( $categories ) {

	$guten_cats = wp_list_pluck( $categories, 'slug' );

	if( ! in_array( 'wpos_guten_block', $guten_cats ) ) {
		$categories[] = array(
							'slug'	=> 'wpos_guten_block',
							'title'	=> __('WPOS Blocks', 'album-and-image-gallery-plus-lightbox'),
							'icon'	=> null,
						);
	}

	return $categories;
}
add_filter( 'block_categories', 'aigpl_pro_add_block_category' );