<?php
/**
 * 'aigpl-gallery-album' Shortcode
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

function aigpl_pro_gallery_album( $atts, $content = null ) {

	// SiteOrigin Page Builder Gutenberg Block Tweak - Do not Display Preview
	if( isset( $_POST['action'] ) && ( $_POST['action'] == 'so_panels_layout_block_preview' || $_POST['action'] == 'so_panels_builder_content_json' ) ) {
		return "[aigpl-gallery-album]";
	}

	// Taking some globals
	global $post, $multipage;

	// Shortcode Parameter
	$atts = shortcode_atts(array( 
		'limit'					=> 15,
		'album_grid'			=> 3,
		'album_design' 			=> 'design-1',
		'album_link_target'		=> 'self',
		'album_height'			=> '',
		'album_title'			=> 'true',
		'album_description'		=> 'true',
		'album_full_content'	=> 'false',
		'words_limit' 			=> 40,
		'content_tail' 			=> '...',
		'order'					=> 'DESC',
		'orderby'				=> 'date',
		'include_cat_child'		=> 'true',
		'id'					=> array(),
		'exclude_post'			=> array(),
		'category' 				=> '',
		'exclude_cat'			=> array(),
		'total_photo'			=> '{total}'.' '.__( 'Photos','album-and-image-gallery-plus-lightbox' ),
		'pagination'			=> 'false',
		'pagination_type'		=> 'numeric',
		'album_masonry'			=> 'false',
		'album_popup'			=> 'false',
		'popup'					=> 'true',
		'grid'					=> 3,
		'gallery_height'		=> '',
		'offset'				=> '',
		'design'				=> 'design-1',
		'show_caption'			=> 'true',
		'show_title'			=> 'false',
		'show_description'		=> 'false',
		'link_target'			=> 'self',
		'image_size'			=> 'full',
		'masonry'				=> 'false',
		'query_offset'			=> '',
		'extra_class'			=> '',
		'className'				=> '',
		'align'					=> '',
	), $atts, 'aigpl-gallery-album');

	$unique_album_no 			= aigpl_pro_unique_num();
	$album_designs 				= aigpl_pro_album_designs();
	$atts['content_tail'] 		= html_entity_decode( $atts['content_tail'] );
	$atts['limit']				= aigpl_pro_clean_number( $atts['limit'], 15, 'number' );
	$atts['album_grid']			= aigpl_pro_clean_number( $atts['album_grid'], 3 );
	$atts['album_height']		= aigpl_pro_clean_number( $atts['album_height'], '' );
	$atts['words_limit']		= aigpl_pro_clean_number( $atts['words_limit'], 40 );
	$atts['query_offset']		= aigpl_pro_clean_number( $atts['query_offset'], '' );
	$atts['post_ids']			= ! empty( $atts['id'] )						? explode(',', $atts['id']) 				: array();
	$atts['album_grid'] 		= ( $atts['album_grid'] <= 12 )					? $atts['album_grid'] 						: 3;
	$atts['album_design'] 		= ( $atts['album_design'] && ( array_key_exists( trim( $atts['album_design'] ), $album_designs ) ) ) ? trim( $atts['album_design'] ) : 'design-1';
	$atts['include_cat_child']	= ( $atts['include_cat_child'] == 'false' )		? false 									: true;	
	$atts['album_link_target'] 	= ( $atts['album_link_target'] == 'blank') 		? '_blank' 									: '_self';
	$atts['album_title']		= ( $atts['album_title'] == 'true')				? 1											: 0;
	$atts['album_description']	= ( $atts['album_description'] == 'true')		? 1											: 0;
	$atts['album_full_content']	= ( $atts['album_full_content'] == 'true')		? 1											: 0;
	$atts['pagination']			= ( $atts['pagination'] == 'true')				? 1											: 0;
	$atts['pagination_type'] 	= ( $atts['pagination_type'] == 'prev-next')	? 'prev-next' 								: 'numeric';
	$atts['order'] 				= ( strtolower( $atts['order'] ) == 'asc' ) 	? 'ASC' 									: 'DESC';
	$atts['orderby'] 			= !empty( $atts['orderby'] )					? $atts['orderby']							: 'date';
	$atts['exclude_post'] 		= ! empty( $atts['exclude_post'] )				? explode(',', $atts['exclude_post']) 		: array();
	$atts['category'] 			= ! empty( $atts['category'] )					? explode(',',$atts['category']) 			: '';
	$atts['exclude_cat']		= ! empty( $atts['exclude_cat'] )				? explode(',', $atts['exclude_cat']) 		: array();
	$atts['total_photo'] 		= ! empty( $atts['total_photo'] ) 				? $atts['total_photo']						: '';
	$atts['album_masonry'] 		= ( $atts['album_masonry'] == 'true' )			? 1											: 0;
	$atts['album_popup']		= ( $atts['album_popup'] == 'true' )			? 1											: 0;
	$atts['align']				= ! empty( $atts['align'] )						? 'align'.$atts['align']					: '';
	$atts['extra_class']		= $atts['extra_class'] .' '. $atts['align'] .' '. $atts['className'];
	$atts['extra_class']		= aigpl_pro_sanitize_html_classes( $atts['extra_class'] );
	$atts['multi_page']			= ( $multipage || is_single() || is_front_page() ) ? 1 : 0;
	$atts['lazyload'] 			= '';
	$album_ses 					= ! empty( $_GET['album_ses'] ) 	? $_GET['album_ses'] : '';

	// Extract Shortcode Var
	extract($atts);

	// Height
	$atts['album_height_css']		= '';
	if( $album_height == 'auto' || ( $album_masonry && empty( $album_height ) ) ) {
		$atts['album_height_css'] 	= "height:auto;";
	} elseif ( !empty( $album_height ) ) {
		$atts['album_height_css'] 	= "height:{$album_height}px;";
	}

	// Taking some global
	global $post;

	// Pagination Variable
	$paged = 1;
	if( $multi_page ) {
		$paged = isset( $_GET['album_page'] ) ? $_GET['album_page'] : 1;
	} else if ( get_query_var('paged') ) {
		$paged = get_query_var('paged');
	} else if ( get_query_var('page') ) {
		$paged = get_query_var('page');
	}

	// Taking care of query offset with pagination
	if( $query_offset && $pagination && $paged > 1 ) {
		$queryoffset = $query_offset + ( ($paged - 1) * $limit );
	} else {
		$queryoffset = $query_offset;
	}


	// If album id passed and album_ses match to passed number
	if ( isset( $_GET['album'] ) && ! empty( $_GET['album'] ) && ( $album_ses == $unique_album_no ) ) {
		$post_ids = $_GET['album'];
	}

	/***** Enqueus Required Script *****/
	// First Dequeue if slider shortcode is placed before the grid shortcode
	if( $album_masonry || $album_popup ) {
		wp_dequeue_script( 'aigpl-pro-public-js' );
	}

	if( $album_masonry ) {
		wp_enqueue_script( 'jquery-masonry' );
	}
	if( $album_popup ) {
		wp_enqueue_script( 'wpos-ilightbox-script' );
	}
	if( $album_masonry || $album_popup ) {
		wp_enqueue_script( 'aigpl-pro-public-js' );
	}

	// Taking some variables
	$prefix 		= AIGPL_PRO_META_PREFIX;
	$album_page 	= get_permalink();
	$loop_count		= 1;
	$atts['unique']	= aigpl_pro_get_unique();
	
	// Taking some class
	$atts['main_wrap_cls']	= "aigpl-album-{$album_design}";
	$atts['main_wrap_cls'] 	.= ( $album_masonry ) ? ' aigpl-gallery-masonry'	: '';
	$atts['main_wrap_cls'] 	.= ( $album_popup ) ? ' aigpl-lightbox-gallery'		: '';

	// If album id is not passed then take all albums else album images
	if( $album_ses != $unique_album_no ) {

		// WP Query Parameters
		$args = array (
			'post_type'				=> AIGPL_PRO_POST_TYPE,
			'post_status' 			=> array( 'publish' ),
			'post__in'		 		=> $post_ids,
			'ignore_sticky_posts'	=> true,
			'posts_per_page'		=> $limit,
			'paged'					=> ( $pagination ) ? $paged : 1,
			'order'					=> $order,
			'orderby'				=> $orderby,
			'post__not_in'			=> $exclude_post,
			'offset'				=> $queryoffset,
		);

		// Meta Query
		$args['meta_query'] = array(
								array(
									'key'		=> $prefix.'gallery_imgs',
									'value'		=> '',
									'compare'	=> '!=',
								));

		// Category Parameter
		if( ! empty( $category ) ) {

			$args['tax_query'] = array(
									array( 
										'taxonomy' 			=> AIGPL_PRO_CAT,
										'field' 			=> 'term_id',
										'terms' 			=> $category,
										'include_children'	=> $include_cat_child,
								));

		} else if( ! empty( $exclude_cat ) ) {
			
			$args['tax_query'] = array(
										array(
											'taxonomy' 			=> AIGPL_PRO_CAT,
											'field' 			=> 'term_id',
											'terms' 			=> $exclude_cat,
											'operator'			=> 'NOT IN',
											'include_children'	=> $include_cat_child,
									));
		}

		// WP Query Parameters
		$args			= apply_filters( 'aigpl_pro_album_grid_query_args', $args, $atts );
		$aigpl_query 	= new WP_Query( $args );

		// Templates Variabals
		$atts['paged']			= $paged;
		$atts['max_num_pages']	= $aigpl_query->max_num_pages;

		// Little tweak for pagination with query offset
		if ( $pagination && $query_offset ) {
			$found_posts			= ( $aigpl_query->found_posts - $query_offset );
			$atts['max_num_pages']	= ceil( $found_posts / $limit );
		}

		// album grid
		$album_grid = ( $album_grid >= $aigpl_query->found_posts) ? $aigpl_query->found_posts : $album_grid;
	}

	ob_start();

	// If post is there
	if ( ($album_ses != $unique_album_no) && $aigpl_query->have_posts() ) {

		aigpl_pro_get_template( 'album/grid/loop-start.php', $atts ); // loop start

		while ( $aigpl_query->have_posts() ) : $aigpl_query->the_post();

			$total_photo_no				= get_post_meta( $post->ID, $prefix.'gallery_imgs', true );
			$total_photo_no 			= ! empty( $total_photo_no )	? count( $total_photo_no ) : '';
			$atts['album_image'] 		= empty( $album_popup )			? esc_url( add_query_arg( array( 'album' => $post->ID, 'album_ses' => $unique_album_no ), $album_page ) ) : 'javascript:void(0);';
			$atts['image_link']			= aigpl_pro_get_image_src( get_post_thumbnail_id( $post->ID ), $image_size, true );
			$atts['album_content'] 		= ( $album_full_content ) ? wpautop( $post->post_content ) : aigpl_pro_get_post_excerpt( $post->ID, $post->post_content, $words_limit, $content_tail );
			$atts['total_photo_lbl']	= str_replace( '{total}', $total_photo_no, $total_photo );

			$atts['wrpper_cls'] 		= "aigpl-cnt-wrp aigpl-col-{$album_grid} aigpl-columns";
			$atts['wrpper_cls']			.= ( $loop_count % $album_grid == 1 ) ? ' aigpl-first' : '';

			// Design Template
			aigpl_pro_get_template( "album/grid/{$album_design}.php", $atts, null, null, "album/designs/{$album_design}.php"  );

			$loop_count++; // Increment loop count

		endwhile;

		aigpl_pro_get_template( 'album/grid/loop-end.php', $atts ); // loop End

		wp_reset_postdata(); // Reset WP Query

	} elseif( ! empty( $_GET['album'] ) && ( $album_ses == $unique_album_no ) ) { // If album id is passed

		echo "<div class='aigpl-breadcrumb-wrp'><a class='aigpl-breadcrumb' href='{$album_page}'>".__( 'Main Album', 'album-and-image-gallery-plus-lightbox' )."</a> &raquo; ".get_the_title( $post_ids )."</div>";

		echo do_shortcode( '[aigpl-gallery id="'.$post_ids.'" grid="'.$grid.'" gallery_height="'.$gallery_height.'" show_title="'.$show_title.'" show_description="'.$show_description.'" show_caption="'.$show_caption.'" popup="'.$popup.'" offset="'.$offset.'" link_target="'.$link_target.'" design="'.$design.'" image_size="'.$image_size.'" masonry="'.$masonry.'"]' );

	} // end else

	$content .= ob_get_clean();
	return $content;
}

// Album grid shortcode
add_shortcode( 'aigpl-gallery-album', 'aigpl_pro_gallery_album' );