<?php
/**
 * 'aigpl-gallery-slider' Shortcode 
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

function aigpl_pro_gallery_slider( $atts, $content = null ) {

	// SiteOrigin Page Builder Gutenberg Block Tweak - Do not Display Preview
	if( isset( $_POST['action'] ) && ( $_POST['action'] == 'so_panels_layout_block_preview' || $_POST['action'] == 'so_panels_builder_content_json' ) ) {
		return "[aigpl-gallery-slider]";
	}

	// Shortcode Parameter
	$atts = shortcode_atts(array(
		'id'				=> array(),
		'design' 			=> 'design-1',
		'link_target'		=> 'self',
		'gallery_height'	=> '',
		'show_title'		=> 'false',
		'show_description'	=> 'false',
		'show_caption'		=> 'true',
		'image_size'		=> 'full',
		'popup'				=> 'true',
		'slidestoshow' 		=> 3,
		'slidestoscroll' 	=> 1,
		'loop' 				=> 'true',
		'dots'				=> 'true',
		'arrows'			=> 'true',
		'autoplay'			=> 'true',
		'autoplay_interval' => 3000,
		'speed'				=> 300,
		'centermode'		=> 'false',
		'hover_pause'		=> 'true',
		'focus_pause'		=> 'false',
		'lazyload'			=> '',
		'extra_class'		=> '',
		'className'			=> '',
		'align'				=> '',
	), $atts, 'aigpl-gallery-slider');

	$shortcode_designs 			= aigpl_pro_gallery_designs();
	$atts['gallery_height']		= aigpl_pro_clean_number( $atts['gallery_height'], '' );
	$atts['slidestoshow']		= aigpl_pro_clean_number( $atts['slidestoshow'], 3 );
	$atts['slidestoscroll']		= aigpl_pro_clean_number( $atts['slidestoscroll'], 1 );
	$atts['autoplay_interval']	= aigpl_pro_clean_number( $atts['autoplay_interval'], 3000 );
	$atts['speed']				= aigpl_pro_clean_number( $atts['speed'], 300 );
	$atts['post_ids']			= ! empty( $atts['id'] )						? explode( ',', $atts['id'] ) 			: array();
	$atts['design'] 			= ( $atts['design'] && ( array_key_exists( trim( $atts['design'] ), $shortcode_designs ) ) ) ? trim( $atts['design'] ) : 'design-1';
	$atts['link_target'] 		= ( $atts['link_target'] == 'blank' ) 			? '_blank' 								: '_self';
	$atts['show_title']			= ( $atts['show_title'] == 'true' )				? 1										: 0;
	$atts['show_description']	= ( $atts['show_description'] == 'true' )		? 1										: 0;
	$atts['show_caption']		= ( $atts['show_caption'] == 'true' )			? 1										: 0;
	$atts['popup']				= ( $atts['popup'] == 'false' )					? 'false'								: 'true';
	$atts['image_size'] 		= ! empty( $atts['image_size'] )				? $atts['image_size']					: $atts['image_size'];
	$atts['loop'] 				= ( $atts['loop'] == 'false' ) 					? 'false' 								: 'true';
	$atts['dots'] 				= ( $atts['dots'] == 'false' ) 					? 'false' 								: 'true';
	$atts['arrows'] 			= ( $atts['arrows'] == 'false' ) 				? 'false' 								: 'true';
	$atts['autoplay'] 			= ( $atts['autoplay'] == 'false' ) 				? 'false' 								: 'true';
	$atts['centermode'] 		= ( $atts['centermode'] == 'true' && ( ( $atts['slidestoshow'] % 2 ) != 0 ) ) ? 'true' 	: 'false';
	$atts['hover_pause'] 		= ( $atts['hover_pause'] == 'false' ) 			? 'false' 								: 'true';
	$atts['focus_pause'] 		= ( $atts['focus_pause'] == 'true' ) 			? 'true' 								: 'false';
	$atts['lazyload'] 			= ( $atts['lazyload'] == 'ondemand' || $atts['lazyload'] == 'progressive' ) ? $atts['lazyload'] : ''; // ondemand or progressive
	$atts['align']				= ! empty( $atts['align'] )						? 'align'.$atts['align']				: '';
	$atts['extra_class']		= $atts['extra_class'] .' '. $atts['align'] .' '. $atts['className'];
	$atts['extra_class']		= aigpl_pro_sanitize_html_classes( $atts['extra_class'] );

	// Extract Shortcode Var
	extract($atts);

	// Height
	$atts['height_css']	= '';
	if( $gallery_height == 'auto' ) {
		$atts['height_css'] = "height:auto;";
	} elseif ( ! empty( $gallery_height ) ) {
		$atts['height_css'] = "height:{$gallery_height}px;";
	}

	// If no id is passed then return
	if( empty( $post_ids ) ) {
		return $content;
	}

	/***** Enqueus Required Script *****/
	// First Dequeue if grid shortcode is placed before the slider shortcode
	wp_dequeue_script( 'aigpl-pro-public-js' );

	if( $popup == 'true' ) {
		wp_enqueue_script( 'wpos-magnific-script' );
	}
	wp_enqueue_script( 'wpos-slick-jquery' );
	wp_enqueue_script( 'aigpl-pro-public-js' );

	// Taking some global
	global $post;

	// Taking some variables
	$prefix 						= AIGPL_PRO_META_PREFIX;
	$atts['count']					= 1;
	$atts['unique']					= aigpl_pro_get_unique();
	$atts['wrpper_cls']				= 'aigpl-slider-slide aigpl-cnt-wrp';
	$atts['popup_cls'] 				= ( $popup == 'true' ) 		? 'aigpl-popup-gallery' 	: '';
	$atts['slider_effect_class']	= ( $centermode == 'true' ) ? ' aigpl-center-mode ' 	: '';
	$atts['offset_css']				= '';

	// Slider configuration
	$atts['slider_conf'] = compact( 'slidestoshow', 'slidestoscroll', 'loop', 'dots', 'arrows', 'autoplay', 'autoplay_interval', 'speed', 'centermode', 'hover_pause', 'focus_pause', 'lazyload' );

	// WP Query Parameters
	$args = array (
		'post_type'				=> AIGPL_PRO_POST_TYPE,
		'post_status' 			=> array( 'publish' ),
		'post__in'		 		=> $post_ids,
		'ignore_sticky_posts'	=> true,
	);

	// Meta Query
	$args['meta_query'] = array(
							array(
								'key'		=> $prefix.'gallery_imgs',
								'value'		=> '',
								'compare'	=> '!=',
							));

	// WP Query Parameters
	$args	= apply_filters( 'aigpl_pro_gallery_slider_query_args', $args, $atts );
	$query 	= new WP_Query( $args );

	ob_start();

	// If post is there
	if ( $query->have_posts() ) {

		aigpl_pro_get_template( 'gallery/slider/loop-start.php', $atts ); // loop start

		while ( $query->have_posts() ) : $query->the_post();

			$gallery_imgs = get_post_meta( $post->ID, $prefix.'gallery_imgs', true );

			if( ! empty( $gallery_imgs ) ) {
				foreach ( $gallery_imgs as $img_key => $img_data ) {

					$atts['gallery_post']		= get_post( $img_data );
					$atts['gallery_img_src'] 	= aigpl_pro_get_image_src( $img_data, $image_size );
					$atts['image_alt_text']		= get_post_meta( $img_data, '_wp_attachment_image_alt', true );

					if( $popup == 'true' ) {
						$atts['image_link']	= aigpl_pro_get_image_src( $img_data, 'full' );
					} else {
						$atts['image_link'] = get_post_meta( $img_data, $prefix.'attachment_link', true );
					}

					if( $atts['gallery_post'] && $design && $atts['gallery_img_src'] ) {

						// Design Template
						aigpl_pro_get_template( "gallery/slider/{$design}.php", $atts, null, null, "gallery/designs/{$design}.php"  );

						$atts['count']++; // Increment loop count
					}
				} // End of for each
			}

		endwhile;

		aigpl_pro_get_template( 'gallery/slider/loop-end.php', $atts ); // loop end
	}

	wp_reset_postdata(); // Reset WP Query

	$content .= ob_get_clean();
	return $content;
}

// Album gallery slider shortcode
add_shortcode( 'aigpl-gallery-slider', 'aigpl_pro_gallery_slider' );