<?php
/**
 * 'aigpl-gallery' Shortcode 
 * 
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.0.0
 */

if ( !defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

function aigpl_pro_gallery_grid( $atts, $content = null ) {

	// SiteOrigin Page Builder Gutenberg Block Tweak - Do not Display Preview
	if( isset( $_POST['action'] ) && ($_POST['action'] == 'so_panels_layout_block_preview' || $_POST['action'] == 'so_panels_builder_content_json') ) {
		return "[aigpl-gallery]";
	}

	// Shortcode Parameter
	$atts = shortcode_atts(array(
			'id'				=> array(),
			'grid'				=> 3,
			'design' 			=> 'design-1',
			'link_target'		=> 'self',
			'offset'			=> '',
			'gallery_height'	=> '',
			'show_title'		=> 'false',
			'show_description'	=> 'false',
			'show_caption'		=> 'true',
			'image_size'		=> 'full',
			'popup'				=> 'true',
			'masonry'			=> 'false',
			'extra_class'		=> '',
			'className'			=> '',
			'align'				=> '',
	), $atts,'aigpl-gallery');

	$shortcode_designs 			= aigpl_pro_gallery_designs();
	$atts['grid']				= aigpl_pro_clean_number( $atts['grid'], 3 );
	$atts['gallery_height']		= aigpl_pro_clean_number( $atts['gallery_height'], '' );
	$atts['post_ids']			= !empty( $atts['id'] )						? explode( ',', $atts['id'] ) 				: array();
	$atts['grid'] 				= ( $atts['grid'] <= 12 )					? $atts['grid']								: 3;
	$atts['design'] 			= ( $atts['design'] && ( array_key_exists( trim( $atts['design'] ), $shortcode_designs ) ) ) ? trim( $atts['design'] ) : 'design-1';
	$atts['link_target'] 		= ( $atts['link_target'] == 'blank') 		? '_blank' 									: '_self';
	$atts['offset_css']			= ( is_numeric( $atts['offset'] ) ) 		? "style='padding:{$atts['offset']}px;'"	: '';
	$atts['show_title']			= ( $atts['show_title'] == 'true' )			? 1											: 0;
	$atts['show_description']	= ( $atts['show_description'] == 'true' )	? 1											: 0;
	$atts['show_caption']		= ( $atts['show_caption'] == 'true' )		? 1											: 0;
	$atts['popup']				= ( $atts['popup'] == 'false' )				? 'false'									: 'true';
	$atts['image_size'] 		= !empty( $atts['image_size'] )				? $atts['image_size']						: $atts['image_size'];
	$atts['masonry'] 			= ( $atts['masonry'] == 'true' )			? 'true'									: 'false';
	$atts['align']				= !empty( $atts['align'] )					? 'align'.$atts['align']					: '';
	$atts['extra_class']		= $atts['extra_class'] .' '. $atts['align'] .' '. $atts['className'];
	$atts['extra_class']		= aigpl_pro_sanitize_html_classes( $atts['extra_class'] );
	$atts['lazyload'] 			= '';
	
	// Extract Shortcode Var
	extract($atts);

	// Height
	$atts['height_css'] = '';
	if( $gallery_height == 'auto' || ( $masonry == 'true' && empty( $gallery_height ) ) ) {
		$atts['height_css'] = "height:auto;";
	} elseif ( !empty( $gallery_height ) ) {
		$atts['height_css'] = "height:{$gallery_height}px;";
	}

	// If no id is passed then return
	if( empty( $post_ids ) ) {
		return $content;
	}

	/***** Enqueus Required Script *****/
	// First Dequeue if slider shortcode is placed before the grid shortcode
	if( $masonry == 'true' || $popup == 'true' ) {
		wp_dequeue_script( 'aigpl-pro-public-js' );
	}

	if( $masonry == 'true' ) {
		wp_enqueue_script( 'jquery-masonry' );
	}
	if( $popup == 'true' ) {
		wp_enqueue_script( 'wpos-magnific-script' );
	}
	if( $masonry == 'true' || $popup == 'true' ) {
		wp_enqueue_script( 'aigpl-pro-public-js' );
	}

	// Taking some global
	global $post;

	// Taking some variables
	$prefix 				= AIGPL_PRO_META_PREFIX;
	$atts['unique']			= aigpl_pro_get_unique();
	$atts['count']			= 1;
	$atts['popup_cls']		= ( $popup == 'true' ) 		? 'aigpl-popup-gallery' 	: '';
	$atts['masonry_cls']	= ( $masonry == 'true' ) 	? 'aigpl-gallery-masonry' 	: '';

	// WP Query Parameters
	$args = array (
		'post_type'				=> AIGPL_PRO_POST_TYPE,
		'post_status' 			=> array( 'publish' ),
		'post__in'		 		=> $post_ids,
		'ignore_sticky_posts'	=> true,
	);

	// WP Query Parameters
	$args	= apply_filters( 'aigpl_pro_gallery_grid_query_args', $args, $atts );
	$query 	= new WP_Query( $args );

	ob_start();

	// If post is there
	if ( $query->have_posts() ) {

		aigpl_pro_get_template( 'gallery/grid/loop-start.php', $atts ); // loop start

		while ( $query->have_posts() ) : $query->the_post();

			$gallery_imgs = get_post_meta( $post->ID, $prefix.'gallery_imgs', true );

			if( !empty($gallery_imgs) ) {
				foreach ($gallery_imgs as $img_key => $img_data) {

					$atts['gallery_post']		= get_post( $img_data );
					$atts['gallery_img_src']	= aigpl_pro_get_image_src( $img_data, $image_size );
					$atts['image_alt_text']		= get_post_meta( $img_data, '_wp_attachment_image_alt', true );

					$atts['wrpper_cls']	= "aigpl-cnt-wrp aigpl-col-{$grid} aigpl-columns";
					$atts['wrpper_cls']	.= ( $atts['count'] % $grid == 1 ) ? ' aigpl-first' : '';

					if( $popup == 'true' ) {
						$atts['image_link']	= aigpl_pro_get_image_src( $img_data, 'full' );
					} else {
						$atts['image_link'] = get_post_meta( $img_data, $prefix.'attachment_link', true );
					}

					if( $atts['gallery_post'] && $design && $atts['gallery_img_src'] ) {
						
						// Include shortcode html file
						aigpl_pro_get_template( "gallery/grid/{$design}.php", $atts, null, null, "gallery/designs/{$design}.php"  );

						$atts['count']++;
					}
				} // End of for each
			}

		endwhile;

		aigpl_pro_get_template( 'gallery/grid/loop-end.php', $atts ); // loop end
	}

	wp_reset_postdata(); // Reset WP Query

	$content .= ob_get_clean();
	return $content;
}

// Album gallery grid shortcode
add_shortcode( 'aigpl-gallery', 'aigpl_pro_gallery_grid' );