<?php
/**
 * Gallery Slider Shortcode Widget
 *
 * @package Album and Image Gallery Plus Lightbox Pro
 * @since 1.4
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

class Aigpl_Pro_Gallery_Slider_Shrt extends Aigpl_Pro_Widget {

	/**
	 * Constructor.
	 */
	public function __construct() {
		$this->widget_id			= 'aigpl-gs-shrt';
		$this->widget_cssclass		= 'aigpl-gs-shrt';
		$this->widget_name			= __( 'Gallery Slider - Shortcode', 'album-and-image-gallery-plus-lightbox' );
		$this->widget_description	= __( 'Display gallery in a slider view. Gallery Slider shortcode.', 'album-and-image-gallery-plus-lightbox' );
		$this->widget_title			= __( 'Gallery Slider', 'album-and-image-gallery-plus-lightbox' );
		$this->settings				= aigpl_gallery_slider_shortcode_fields();
		$this->defaults				= $this->default_settings();

		parent::__construct();
	}

	/**
	 * Output widget.
	 *
	 * @see WP_Widget
	 *
	 * @param array $args     Arguments.
	 * @param array $instance Widget instance.
	 */
	public function widget( $args, $instance ) {

		$instance = wp_parse_args( (array)$instance, $this->defaults );

		$this->widget_start( $args, $instance );

		echo aigpl_pro_gallery_slider( $instance );

		$this->widget_end( $args, $instance );
	}
}