<?php
/**
 * Template for Design 1
 *
 * This template can be overridden by copying it to yourtheme/album-and-image-gallery-plus-lightbox-pro/gallery/designs/design-1.php
 *
 * If you want to override for grid only then put it into 'grid' folder and same for respective.
 *
 * @package Album and Image Gallery Plus Lightbox Pro
 * @version 1.2.7
 */

if ( !defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $post; ?>

<div class="<?php echo $wrpper_cls; ?>" <?php echo $offset_css; ?> data-item-index="<?php echo $count; ?>">
	<div class="aigpl-inr-wrp">
		<div class="aigpl-img-wrp" style="<?php echo $height_css; ?>">
			<?php if( $image_link ) { 
			if( $popup == 'true' ) { ?>
				<a class="aigpl-img-link" data-mfp-src="<?php echo esc_url( $image_link ); ?>" href="javascript:void(0);" target="<?php echo $link_target; ?>">
			<?php } else { ?>
				<a class="aigpl-img-link" href="<?php echo esc_url( $image_link ); ?>" target="<?php echo $link_target; ?>">
			<?php } ?>
				<img class="aigpl-img" <?php if($lazyload) { ?>data-lazy="<?php echo esc_url($gallery_img_src); ?>" <?php } ?> src="<?php if(empty($lazyload)) { echo esc_url($gallery_img_src); } ?>" title="<?php echo aigpl_pro_esc_attr( $gallery_post->post_title ); ?>" alt="<?php echo aigpl_pro_esc_attr( $image_alt_text ); ?>" />
			</a>
			<?php } else { ?>
				<img class="aigpl-img" <?php if($lazyload) { ?>data-lazy="<?php echo esc_url($gallery_img_src); ?>" <?php } ?> src="<?php if(empty($lazyload)) { echo esc_url($gallery_img_src); } ?>" title="<?php echo aigpl_pro_esc_attr( $gallery_post->post_title ); ?>" alt="<?php echo aigpl_pro_esc_attr( $image_alt_text ); ?>" />
			<?php } ?>
			<?php if( $show_caption && $gallery_post->post_excerpt ) { ?>
			<div class="aigpl-img-caption">
				<?php echo $gallery_post->post_excerpt; ?>
			</div>
			<?php } ?>
		</div>

		<?php if( $show_title &&  !empty( $gallery_post->post_title ) ) { ?>
		<div class="aigpl-img-title aigpl-center"><?php echo $gallery_post->post_title; ?></div>
		<?php } ?>

		<?php if( $show_description && !empty( $gallery_post->post_content ) ) { ?>
		<div class="aigpl-img-desc aigpl-center"><?php echo wpautop( $gallery_post->post_content ); ?></div>
		<?php } ?>

		<?php do_action('aigpl_after_img_data', $gallery_post); ?>

	</div>
</div>